<template>
  <div>
    <ValidationObserver v-slot="{ handleSubmit }">
      <form>
        <h3 class="line-header">
          <img
            src="@/assets/icons/user-group.svg"
            alt="Icone entreprise"
          /> Groupe d'organisations
        </h3>
        <div class="form-row">
          <div class="form-group col-12">
            <label class="required">Nom du groupe d'organisations</label>
            <p>Inscrire le nom complet et en toutes lettres du groupe d'organisations. Ex: Communauté des Communes Rurales de l'Entre-Deux-Mers</p>
            <ValidationProvider ref="display_name" rules="required" v-slot="{ classes, errors }">
              <div class="control" :class="classes">
                <input
                  v-model="formData.displayName"
                  class="form-control"
                  type="text"
                  placeholder="Nom du groupe d'organisations"
                >
                <span class="form-errors">{{ errors[0] }}</span>
              </div>
            </ValidationProvider>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-12">
            <label>Description</label>
            <textarea
              v-model="formData.description"
              class="form-control"
            />
          </div>
        </div>
        <div class="form-footer">
          <b-button
            variant="outline-secondary"
            @click="$router.go(-1)"
          >
            Annuler
          </b-button>
          <b-button
            variant="primary"
            style="float: right"
            @click="handleSubmit(saveSphere)"
          >
            Enregistrer les modifications
          </b-button>
        </div>
      </form>
    </ValidationObserver>
  </div>
</template>

<script>
import { mapState } from 'vuex';

import { ValidationObserver, ValidationProvider, extend, configure } from 'vee-validate';
import { required } from 'vee-validate/dist/rules';
extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

export default {
  name: 'SphereForm',

  components: {
    ValidationObserver,
    ValidationProvider
  },

  props: {
    sphere: {
      type: Object,
      default: () => { return {} }
    }
  },

  data() {
    return {
      formData: {
        displayName: null,
        description: null
      }
    }
  },

  computed: {
    ...mapState('usergroups', ['currentUsergroup'])
  },

  created() {
    this.formData.displayName = this.sphere.display_name;
    this.formData.description = this.sphere.description;
  },

  methods: {
    saveSphere() {
      const data = {
        ...this.currentUsergroup,
        ...this.formData.displayName && {display_name: this.formData.displayName},
        ...this.formData.description && {description: this.formData.description}
      };
      this.$emit('save', data);
    }
  }
}
</script>
